Name: bzip2
Version: 1.0.8
Release: 1
License: bzip2-1.0.6
Summary: Lossless, block-sorting data compression tool
Url: https://sourceware.org/bzip2/

BuildRequires: pase-build-tools

Source0: https://sourceware.org/pub/bzip2/bzip2-%{version}.tar.gz

Patch0: bzip2-Makefile.patch

Patch59: bzip2-1.0.7-bzip2recover-do-not-overwite-existing.patch

%description
bzip2 is a freely available, patent free, high-quality data compressor. It
typically compresses files to within 10% to 15% of the best available techniques
(the PPM family of statistical compressors), whilst being around twice as fast
at compression and six times faster at decompression.

%package -n libbz2-1
Summary: bzip2 library

%description -n libbz2-1
bzip2 library

%package devel
Summary: bzip2 development files
Requires: libbz2-1 = %{version}-%{release}

%description devel
bzip2 development files

%prep
%setup -q

%patch0 -p1

%patch59 -p1

perl -p -i -e 's|#!/bin/sh|#!/QOpenSys/usr/bin/sh|g' bzdiff bzgrep bzmore


%build

MAKE=`which make`

# generate a script to wrap the make call
# with all the parameters that we need
cat > _make <<EOF
#!/usr/bin/env bash

#   CFLAGS='-Wall -Winline -O2 -g -fPIC -D_FILE_OFFSET_BITS=64'
$MAKE \
  PREFIX=%{_prefix} \
  DESTDIR=%{buildroot} \
  LIB=%{_lib} \
  CC="gcc -maix${OBJECT_MODE}" \
  LDFLAGS='-Wl,-brtl -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L%{_libdir}' \
  "\$@"
EOF

chmod +x _make

./_make all

svr4-shrlib libbz2.so.1 libbz2.so.1 %{_arch}

./_make all

%install

./_make install

rm %{buildroot}/%{_libdir}/libbz2.a

mkdir %{buildroot}/%{_datadir} 
mv %{buildroot}/%{_prefix}/man %{buildroot}/%{_mandir}

# Change copies to hard links
cd %{buildroot}%{_bindir}
for f in bunzip2 bzcat bzip2recover
do
  rm $f
  ln bzip2 $f
done

for f in bzegrep bzfgrep
do
  rm $f
  ln bzgrep $f
done

rm bzless
ln bzmore bzless

rm bzcmp
ln bzdiff bzcmp

%files
%defattr(-, qsys, *none)

%{_mandir}/man1/bzegrep.1*
%{_mandir}/man1/bzcmp.1*
%{_mandir}/man1/bzip2.1*
%{_mandir}/man1/bzmore.1*
%{_mandir}/man1/bzdiff.1*
%{_mandir}/man1/bzgrep.1*
%{_mandir}/man1/bzfgrep.1*
%{_mandir}/man1/bzless.1*
%{_bindir}/bzcat
%{_bindir}/bzmore
%{_bindir}/bzegrep
%{_bindir}/bzip2
%{_bindir}/bzless
%{_bindir}/bzdiff
%{_bindir}/bzgrep
%{_bindir}/bzcmp
%{_bindir}/bzfgrep
%{_bindir}/bunzip2
%{_bindir}/bzip2recover


%files -n libbz2-1
%defattr(-, qsys, *none)

%{_libdir}/libbz2.so.1


%files devel
%defattr(-, qsys, *none)

%{_libdir}/libbz2.so
%{_includedir}/bzlib.h


%changelog
* Thu Feb 22 2024 Abdirahim Musse <abdirahim.musse@ibm.com> - 1.0.8
- Update to 1.0.8
- Drop patches that have been upstreamed

* Thu Nov 4 2021 Jason Hansen <stymie@us.ibm.com> - 1.0.6
- Intra-package Requires need version and release

* Wed May 27 2020 Kevin Adler <kadler@us.ibm.com> - 1.0.6
- Use generic paths for man and info pages to allow for compression

* Tue Jul 16 2019 Kevin Adler <kadler@us.ibm.com> - 1.0.6
- Update URL and source URL after bzip2.org went away
- Fix package summaries, descriptions, and license
- Fix CVE-2016-3189 and CVE-2019-12900

* Tue Mar 26 2019 Kevin Adler <kadler@us.ibm.com> - 1.0.6
- ibm-build-tools -> pase-build-tools

* Mon Aug 06 2018 - Kevin Adler <kadler@us.ibm.com>
- Disable building with multiple jobs due to build errors
- Build is fast enough it's not worth fixing

* Sat Aug 04 2018 - Kevin Adler <kadler@us.ibm.com>
- Build with multiple jobs

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- use perl -pie instead of GNU sed -i
- Remove gcc wrappers
- Add BuildRequires
- various other fixes

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Mass replace svr4_shlib.sh -> svr4-shrlib

* Tue Dec 26 2017 - Kevin Adler <kadler@us.ibm.com>
- Add missing sed-gnu BuildRequires

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix shebang line and hardlinks in bzip2 package

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove 64-bit GCC script workaround

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix bzip2 build script
- update Makefile to only build .so.1
- use -d flag to cp to copy the link
- add defattr to devel package

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Use auto dependency resolution instead of requiring pase-libs

* Tue Nov 07 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix license
